import * as plugins from '../plugins.js';
import * as authInterfaces from '../data/auth.js';

// Admin Login
export interface IReq_AdminLoginWithUsernameAndPassword extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_AdminLoginWithUsernameAndPassword
> {
  method: 'adminLoginWithUsernameAndPassword';
  request: {
    username: string;
    password: string;
  };
  response: {
    identity?: authInterfaces.IIdentity;
  };
}

// Admin Logout
export interface IReq_AdminLogout extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_AdminLogout
> {
  method: 'adminLogout';
  request: {
    identity: authInterfaces.IIdentity;
  };
  response: {
    success: boolean;
  };
}

// Verify Identity
export interface IReq_VerifyIdentity extends plugins.typedrequestInterfaces.implementsTR<
  plugins.typedrequestInterfaces.ITypedRequest,
  IReq_VerifyIdentity
> {
  method: 'verifyIdentity';
  request: {
    identity: authInterfaces.IIdentity;
  };
  response: {
    valid: boolean;
    identity?: authInterfaces.IIdentity;
  };
}